import 'dart:async';
import 'package:bolter_flutter/bolter_flutter.dart';
import 'package:flutter/material.dart';

part 'presenter/presenter.dart';

part 'presenter/presenter_provider.dart';

part 'sync_builder.dart';

class BolterProvider extends InheritedWidget {
  final BolterInterface _bolter;

  const BolterProvider(
    this._bolter, {
    Key? key,
    required Widget child,
  }) : super(key: key, child: child);

  @override
  bool updateShouldNotify(covariant InheritedWidget oldWidget) => false;
}

extension BolterExtension on BuildContext {
  BolterInterface get bolter =>
      dependOnInheritedWidgetOfExactType<BolterProvider>()?._bolter ?? defaultBolter;
}
