part of '../bolter_provider.dart';

abstract class Presenter<P extends Presenter<P>> {
  late final BolterInterface _bolter = _context.bolter;
  late BuildContext _context;
  late final itSelf = this as P;

  BuildContext get context => _context;

  @protected
  FutureOr<void> onLayout() {}

  @protected
  void initState() {}

  @protected
  @mustCallSuper
  void dispose() {}

  FutureOr<void> perform<T>({
    void Function()? beforeAction,
    FutureOr<T> Function()? action,
    void Function()? afterAction,
    void Function(Object e)? onError,
    BolterNotification? exactNotification,
  }) {
    return _bolter.runAndUpdate(
      beforeAction: beforeAction,
      action: action,
      afterAction: afterAction,
      onError: onError,
    );
  }
}
